#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_ActivityMonsterCumulativeCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<M_ActivityMonsterCumulativeCFG> M_ActivityMonsterCumulativeCFG::msSingleton(nullptr);

int M_ActivityMonsterCumulativeCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityMonsterCumulativeCFGData* M_ActivityMonsterCumulativeCFG::GetData(int Id)
{
	auto it = mMapData.find(Id);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_ActivityMonsterCumulativeCFGData>& M_ActivityMonsterCumulativeCFG::GetMapData()
{
	return mMapData;
}

void M_ActivityMonsterCumulativeCFG::Reload()
{
	mMapData.clear();
	Load();
}

void M_ActivityMonsterCumulativeCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityMonsterCumulativeCFGData data;
		data.mId = element->IntAttribute("Id");
		data.mStarNumber = element->IntAttribute("StarNumber");
		{
			const char* AwardItemID = element->Attribute("AwardItemID");
			std::vector<std::string> vecAwardItemID;
			boost::split(vecAwardItemID, AwardItemID, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecAwardItemID.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecAwardItemID[i].c_str(), &temp))
				{
					data.mAwardItemID.push_back(temp);
				}
			}
		}
		{
			const char* AwardItemCounts = element->Attribute("AwardItemCounts");
			std::vector<std::string> vecAwardItemCounts;
			boost::split(vecAwardItemCounts, AwardItemCounts, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecAwardItemCounts.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecAwardItemCounts[i].c_str(), &temp))
				{
					data.mAwardItemCounts.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mId) != mMapData.end())std::cout <<"data refind:" << data.mId << std::endl;
		assert(mMapData.find(data.mId) == mMapData.end());
		mMapData.insert(std::make_pair(data.mId, data));
		element = element->NextSiblingElement();
	}
}

void M_ActivityMonsterCumulativeCFG::Load()
{
	Load("../Config/M_ActivityMonsterCumulativeCFG.xml");
}

M_ActivityMonsterCumulativeCFG* M_ActivityMonsterCumulativeCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityMonsterCumulativeCFG());
	}
	return msSingleton.get();
}
